/* assert.c : The assertfail routine.
** 
** This file defines the assertfail routine, called by the ASSERT macro.
**
** Chris Butcher, 19 May 1998
*/

#include "mirage.h"

#ifdef USE_NAMESPACES
namespace Mirage {
#endif

// Called if an assertion fails. Prints out the details of the assertion.
void assertfail(char *filename, int linenum, char *assertion)
{
  fprintf(stderr, "\n\n");
  fprintf(stderr, "FATAL ERROR: ASSERTION FAILED\n");
  fprintf(stderr, "=============================\n");
  fprintf(stderr, "%s:%d  ASSERT(%s)\n", filename, linenum, assertion);
}

#ifdef USE_NAMESPACES
} // namespace Mirage {
#endif
