/* assert.h : The ASSERT macro.
** 
** This file defines the ASSERT macro, used for debugging and error-case
** handling.
**
** Chris Butcher, 19 May 1998
*/

#define ASSERTFAIL_EXITCODE -1

// Usage of the ASSERT macro:
//
// void check_struct(blahstruct *check)
// {
//   ASSERT(check != NULL);
//   ASSERT(check->checkbyte == BLAHSTRUCT_CHECKBYTE);
// }
#define ASSERT(expr) {                               \
  if (!(expr)) {                                     \
    assertfail(__FILE__, __LINE__, __STRING(expr));  \
    exit(ASSERTFAIL_EXITCODE);                       \
  }                                                  \
}

// Prototype for assertfail.
void assertfail(char *filename, int linenum, char *assertion);
