/* rand48.h : Header file for the rand48 routines
** 
** This file defines the constants and prototypes for the Mirage
** implementation of the rand48 routines written by Martin Birgmeier.
**
** Chris Butcher, 16 September 1997
*/

#ifdef USE_OWN_DRAND48

// Mirage prefers to use the rand48 routines provided with the system.
// However if they aren't there, it provides its own.

/*
 * Copyright (c) 1993 Martin Birgmeier
 * All rights reserved.
 *
 * You may redistribute unmodified or modified versions of this source
 * code provided that the above copyright notice and this and the
 * following conditions are retained.
 *
 * This software is provided ``as is'', and comes with no warranties
 * of any kind. I shall in no event be liable for anything that happens
 * to anyone/anything when using this software.
 */

#define	MIRAGE_RAND48_SEED_0	(0x330e)
#define	MIRAGE_RAND48_SEED_1	(0xabcd)
#define	MIRAGE_RAND48_SEED_2	(0x1234)
#define	MIRAGE_RAND48_MULT_0	(0xe66d)
#define	MIRAGE_RAND48_MULT_1	(0xdeec)
#define	MIRAGE_RAND48_MULT_2	(0x0005)
#define	MIRAGE_RAND48_ADD	(0x000b)

extern unsigned short __mirage_rand48_seed[3];
extern unsigned short __mirage_rand48_mult[3];
extern unsigned short __mirage_rand48_add;

double drand48(void);
double erand48(unsigned short xseed[3]);
long   jrand48(unsigned short xseed[3]);
void   lcong48(unsigned short p[7]);
long   lrand48(void);
long   mrand48(void);
long   nrand48(unsigned short xseed[3]);
void   srand48(long seed);
unsigned short *seed48(unsigned short xseed[3]);
void   __mirage_dorand48(unsigned short[3]);

#endif // USE_OWN_DRAND48
