/* raytrace.h : Definitions for the StandardRayTracer and supporting code.
** 
** This file defines the functions and classes necessary to trace rays.
**
** Chris Butcher, 26 January 1998
*/

// Standard ray tracing engine.
class StandardRayTracer  : public RayTracer {
public:
  // Trace a ray.
  virtual void traceRay(primnode *world_object,
			vector ray_from, vector ray_dir,
			uint ray_flags, signature ray_signature,
			SfxType start_sfxtype, void *start_sfx,
			double light_t, color ray_contribution,
			primnode **hit_object,
			double *hit_t, vector hit_normal,
			vector hit_point, color hit_color,
			int max_ray_depth);

  virtual ~StandardRayTracer(void) {
  }
};

// Routines used by primitives to insert intersections.
void insert_entering(class IntersectionList *the_list, primnode *node,
		     primnode *validate_node, vector normal, double t_val,
		     vector ray_from, vector ray_dir, uint ray_flags);
void insert_leaving(class IntersectionList *the_list, primnode *node,
		     primnode *validate_node, vector normal, double t_val,
		     vector ray_from, vector ray_dir, uint ray_flags);








