/* types.h : Types defined for the Mirage system.
** 
** This file contains all of the enumerated types and typedefs
** that are needed in Mirage.
**
** Chris Butcher, 26 January 1996
*/

/*
 * Enumerated types
 */

// The W component is the homogenous component traditionally; however,
// standard vectors have only X, Y, and Z. We use the W location for
// quaternions, to store the scalar component.
enum axis             {X = 0, Y = 1, Z = 2, W = 3};
enum colorindex       {R = 0, G = 1, B = 2, ER = 3, EG = 4, EB = 5, A = 6};
enum linktype         {PLUS = 0, MINUS, PAINTMINUS, AND, SURF_AND};
enum filetype         {NONE = 0, PPM, PPM_GZ, TIFF, PNG};
enum intersect_result {IN, OUT, SURFACE};
enum matrixindex      {FORE = 0, AFT = 1};
enum pixmap_type      {B_W, GRAYSCALE, COLOR};
enum texture_tiling   {SINGLE, TILED};
enum texture_method   {TEXMETHOD_OPAQUE, TEXMETHOD_TRANSPARENT};
enum time_pt_type     {POS = 0, TIME = 1};
enum plane_intersect  {ENTRY, EXIT};
enum validate_type    {VALIDATE_PRIMNODE, VALIDATE_RCSG};
enum SfxType          {NOSFX = 0, GASEOUS, DISTORTION};

// LimitedLight dropoff functions. LL_CUSTOM is reserved for internal use.
enum dropoff_type {LL_NONE, LL_LINEAR, LL_SQUARE, LL_CUBIC, LL_CUSTOM};


/*
 * Type definitions
 */

typedef unsigned int uint;
typedef uint signature;
typedef class Dagnode *object;
typedef unsigned short height_val;
typedef unsigned short isosurface_val;
typedef unsigned char byte;
